Index: palm/trunk/SOURCE/init_grid.f90
===================================================================
--- palm/trunk/SOURCE/init_grid.f90	(revision 4901)
+++ palm/trunk/SOURCE/init_grid.f90	(revision 1)
@@ -589,100 +142,115 @@
     DO  k = 1, nzt+1
        dzu(k)  = zu(k) - zu(k-1)
-       ddzu(k) = 1.0_wp / dzu(k)
+       ddzu(k) = 1.0 / dzu(k)
        dzw(k)  = zw(k) - zw(k-1)
-       ddzw(k) = 1.0_wp / dzw(k)
+       ddzw(k) = 1.0 / dzw(k)
     ENDDO
 
     DO  k = 1, nzt
-       dd2zu(k) = 1.0_wp / ( dzu(k) + dzu(k+1) )
-    ENDDO
-
-!
-!-- The FFT- SOR-pressure solvers assume grid spacings of a staggered grid everywhere. For the
-!-- actual grid, the grid spacing at the lowest level is only dz/2, but should be dz. Therefore, an
-!-- additional array containing with appropriate grid information is created for these solvers.
-    IF ( psolver(1:9) /= 'multigrid' )  THEN
-       ALLOCATE( ddzu_pres(1:nzt+1) )
-       ddzu_pres = ddzu
-       ddzu_pres(1) = ddzu_pres(2)  ! change for lowest level
+       dd2zu(k) = 1.0 / ( dzu(k) + dzu(k+1) )
+    ENDDO
+
+!
+!-- In case of multigrid method, compute grid lengths and grid factors for the
+!-- grid levels
+    IF ( psolver == 'multigrid' )  THEN
+
+       ALLOCATE( ddx2_mg(maximum_grid_level), ddy2_mg(maximum_grid_level), &
+                 dzu_mg(nzb+1:nzt+1,maximum_grid_level),                   &
+                 dzw_mg(nzb+1:nzt+1,maximum_grid_level),                   &
+                 f1_mg(nzb+1:nzt,maximum_grid_level),                      &
+                 f2_mg(nzb+1:nzt,maximum_grid_level),                      &
+                 f3_mg(nzb+1:nzt,maximum_grid_level) )
+
+       dzu_mg(:,maximum_grid_level) = dzu
+       dzw_mg(:,maximum_grid_level) = dzw
+       nzt_l = nzt
+       DO  l = maximum_grid_level-1, 1, -1
+           dzu_mg(nzb+1,l) = 2.0 * dzu_mg(nzb+1,l+1)
+           dzw_mg(nzb+1,l) = 2.0 * dzw_mg(nzb+1,l+1)
+           nzt_l = nzt_l / 2
+           DO  k = 2, nzt_l+1
+              dzu_mg(k,l) = dzu_mg(2*k-2,l+1) + dzu_mg(2*k-1,l+1)
+              dzw_mg(k,l) = dzw_mg(2*k-2,l+1) + dzw_mg(2*k-1,l+1)
+           ENDDO
+       ENDDO
+
+       nzt_l = nzt
+       dx_l  = dx
+       dy_l  = dy
+       DO  l = maximum_grid_level, 1, -1
+          ddx2_mg(l) = 1.0 / dx_l**2
+          ddy2_mg(l) = 1.0 / dy_l**2
+          DO  k = nzb+1, nzt_l
+             f2_mg(k,l) = 1.0 / ( dzu_mg(k+1,l) * dzw_mg(k,l) )
+             f3_mg(k,l) = 1.0 / ( dzu_mg(k,l)   * dzw_mg(k,l) )
+             f1_mg(k,l) = 2.0 * ( ddx2_mg(l) + ddy2_mg(l) ) + &
+                          f2_mg(k,l) + f3_mg(k,l)
+          ENDDO
+          nzt_l = nzt_l / 2
+          dx_l  = dx_l * 2.0
+          dy_l  = dy_l * 2.0
+       ENDDO
+
     ENDIF
 
 !
 !-- Compute the reciprocal values of the horizontal grid lengths.
-    ddx = 1.0_wp / dx
-    ddy = 1.0_wp / dy
+    ddx = 1.0 / dx
+    ddy = 1.0 / dy
     dx2 = dx * dx
     dy2 = dy * dy
-    ddx2 = 1.0_wp / dx2
-    ddy2 = 1.0_wp / dy2
-
-!
-!-- Allocate 3D array to set topography
-    ALLOCATE( topo(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-    topo = 0
-!
-!-- Initialize topography by generic topography or read topography from file.
-    CALL init_topo( topo )
-!
-!-- Set flags to mask topography on the grid.
-    CALL set_topo_flags( topo )
-
-!
-!-- Determine the maximum level of topography. It is used for steering the degradation of order of
-!-- the applied advection scheme, as well in the lpm.
-    k_top = 0
-    DO  i = nxl, nxr
-       DO  j = nys, nyn
-          DO  k = nzb, nzt + 1
-             k_top = MAX( k_top, MERGE( k, 0, .NOT. BTEST( topo(k,j,i), 0 ) ) )
-          ENDDO
-       ENDDO
-    ENDDO
-#if defined( __parallel )
-    CALL MPI_ALLREDUCE( k_top, nzb_max, 1, MPI_INTEGER, MPI_MAX, comm2d, ierr )
-#else
-    nzb_max = k_top
-#endif
-!
-!-- Increment nzb_max by 1 in order to allow for proper diverengence correction.
-!-- Further, in case topography extents up to the model top, limit to nzt.
-    nzb_max = MIN( nzb_max+1, nzt )
-!
-!-- Determine minimum index of topography. Usually, this will be nzb. In case there is elevated
-!-- topography, however, the lowest topography will be higher.
-!-- This index is e.g. used to calculate mean first-grid point atmosphere temperature, surface
-!-- pressure and density, etc. .
-    topo_min_level   = 0
-#if defined( __parallel )
-    CALL MPI_ALLREDUCE( MINVAL( topo_top_ind(nys:nyn,nxl:nxr,0) ), topo_min_level, 1, MPI_INTEGER, &
-                        MPI_MIN, comm2d, ierr )
-#else
-    topo_min_level = MINVAL( topo_top_ind(nys:nyn,nxl:nxr,0) )
-#endif
-
-!
-!-- Check topography for consistency with model domain. Therefore, use maximum and minium
-!-- topography-top indices. Note, minimum topography top index is already calculated.
-    IF ( TRIM( topography ) /= 'flat' )  THEN
-#if defined( __parallel )
-       CALL MPI_ALLREDUCE( MAXVAL( topo_top_ind(nys:nyn,nxl:nxr,0) ), nzb_local_max, 1,            &
-                           MPI_INTEGER, MPI_MAX, comm2d, ierr )
-#else
-       nzb_local_max = MAXVAL( topo_top_ind(nys:nyn,nxl:nxr,0) )
-#endif
-       nzb_local_min = topo_min_level
-!
-!--    Consistency checks
-       IF ( nzb_local_min < 0  .OR.  nzb_local_max  > nz + 1 )  THEN
-          WRITE( message_string, * ) 'nzb_local values are outside the model domain',              &
-                                     '&MINVAL( nzb_local ) = ', nzb_local_min,                     &
-                                     '&MAXVAL( nzb_local ) = ', nzb_local_max
-          CALL message( 'init_grid', 'PA0210', 1, 2, 0, 6, 0 )
-       ENDIF
-    ENDIF
-!
-!-- Define vertical gridpoint from (or to) which on the usual finite difference form (which does not
-!-- use surface fluxes) is applied.
-    IF ( constant_flux_layer  .OR.  use_surface_fluxes )  THEN
+    ddx2 = 1.0 / dx2
+    ddy2 = 1.0 / dy2
+
+!
+!-- Compute the grid-dependent mixing length.
+    DO  k = 1, nzt
+       l_grid(k)  = ( dx * dy * dzw(k) )**0.33333333333333
+    ENDDO
+
+!
+!-- Allocate outer and inner index arrays for topography and set
+!-- defaults
+    ALLOCATE( corner_nl(nys:nyn,nxl:nxr), corner_nr(nys:nyn,nxl:nxr), &
+              corner_sl(nys:nyn,nxl:nxr), corner_sr(nys:nyn,nxl:nxr), &
+              nzb_local(-1:ny+1,-1:nx+1), nzb_tmp(-1:ny+1,-1:nx+1),   &
+              wall_l(nys:nyn,nxl:nxr), wall_n(nys:nyn,nxl:nxr),       &
+              wall_r(nys:nyn,nxl:nxr), wall_s(nys:nyn,nxl:nxr) )
+    ALLOCATE( fwxm(nys-1:nyn+1,nxl-1:nxr+1), fwxp(nys-1:nyn+1,nxl-1:nxr+1), &
+              fwym(nys-1:nyn+1,nxl-1:nxr+1), fwyp(nys-1:nyn+1,nxl-1:nxr+1), &
+              fxm(nys-1:nyn+1,nxl-1:nxr+1), fxp(nys-1:nyn+1,nxl-1:nxr+1),   &
+              fym(nys-1:nyn+1,nxl-1:nxr+1), fyp(nys-1:nyn+1,nxl-1:nxr+1),   &
+              nzb_s_inner(nys-1:nyn+1,nxl-1:nxr+1),                         &
+              nzb_s_outer(nys-1:nyn+1,nxl-1:nxr+1),                         &
+              nzb_u_inner(nys-1:nyn+1,nxl-1:nxr+1),                         &
+              nzb_u_outer(nys-1:nyn+1,nxl-1:nxr+1),                         &
+              nzb_v_inner(nys-1:nyn+1,nxl-1:nxr+1),                         &
+              nzb_v_outer(nys-1:nyn+1,nxl-1:nxr+1),                         &
+              nzb_w_inner(nys-1:nyn+1,nxl-1:nxr+1),                         &
+              nzb_w_outer(nys-1:nyn+1,nxl-1:nxr+1),                         &
+              nzb_diff_s_inner(nys-1:nyn+1,nxl-1:nxr+1),                    &
+              nzb_diff_s_outer(nys-1:nyn+1,nxl-1:nxr+1),                    &
+              nzb_diff_u(nys-1:nyn+1,nxl-1:nxr+1),                          &
+              nzb_diff_v(nys-1:nyn+1,nxl-1:nxr+1),                          &
+              nzb_2d(nys-1:nyn+1,nxl-1:nxr+1),                              &
+              wall_e_x(nys-1:nyn+1,nxl-1:nxr+1),                            &
+              wall_e_y(nys-1:nyn+1,nxl-1:nxr+1),                            &
+              wall_u(nys-1:nyn+1,nxl-1:nxr+1),                              &
+              wall_v(nys-1:nyn+1,nxl-1:nxr+1),                              &
+              wall_w_x(nys-1:nyn+1,nxl-1:nxr+1),                            &
+              wall_w_y(nys-1:nyn+1,nxl-1:nxr+1) )
+
+    ALLOCATE( l_wall(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+
+    nzb_s_inner = nzb;  nzb_s_outer = nzb
+    nzb_u_inner = nzb;  nzb_u_outer = nzb
+    nzb_v_inner = nzb;  nzb_v_outer = nzb
+    nzb_w_inner = nzb;  nzb_w_outer = nzb
+
+!
+!-- Define vertical gridpoint from which on the usual finite difference
+!-- form (which does not use surface fluxes) is applied 
+    IF ( prandtl_layer  .OR.  use_surface_fluxes )  THEN
        nzb_diff = nzb + 2
     ELSE
